
import { Component, Vue } from "vue-property-decorator";
import { UserModule } from "@/store/modules/user";
import { Toast } from "@/utils/toast";
import { UsersService } from "@/services/users";
import PasswordPage from "@/modals/password/password.vue";

@Component({
  name: "Profile",
  components: {},
})
export default class extends Vue {
  userInfo = UserModule.userInfo;

  open() {
    this.$prompt("", `修改账户名称`, {
      confirmButtonText: "确定修改",
      cancelButtonText: "取消",
      inputPlaceholder: `请输入新名称`,
      inputValidator: (value) => value.trim()?.length >= 6,
      inputErrorMessage: `至少 2 个字符`,
    })
      .then((res: any) => {
        this.userInfo.name = res.value?.trim();
        UsersService.update(this.userInfo).then((res) => {
          Toast.success("修改成功", "修改账户名称");
        });
      })
      .catch((ex) => ex);
  }
  async modify() {
    const modal = this.$modal.create(PasswordPage, { center: true });
    modal.present();
    const { data } = await modal.onDismissed();
    data && UserModule.LogOut();
  }
}